rho.f <- function(x,y,p.x,p.y,n) {
  
  x.1 <- x*n
  x.2 <- y*n
  x.3 <- (1.0-(x+y))*n
  
  #log.a <- log(n+1) + log(n+2) - log(2)
  log.a <- 2*log(n)-log(1+(p.x^n+p.y^n+(1-p.x-p.y)^n)/6-((1-p.x)^n+(1-p.y)^n+(p.x+p.y)^n)/2)
  
  r <-  log.a +
    lgamma(n+1)-lgamma(x.1+1)-lgamma(x.2+1)-lgamma(x.3+1) 
  
  if(p.x>0){
    r <- r+x.1*log(p.x)
  }
  if(p.y>0){
    r <- r+x.2*log(p.y)
  }
  if((1-p.x-p.y)>0){
    r <- r+x.3*log(1-p.x-p.y)
  }
  
  return(r)
}
